diff -urN cargo-0.89.0-orig/src/cargo/sources/path.rs cargo-0.89.0/src/cargo/sources/path.rs
--- cargo-0.89.0-orig/src/cargo/sources/path.rs	2025-05-10 20:10:32 +0900
+++ cargo-0.89.0/src/cargo/sources/path.rs	2025-08-10 06:03:38 +0900
@@ -19,9 +19,6 @@
 use anyhow::Context as _;
 use cargo_util::paths;
 use filetime::FileTime;
-use gix::bstr::{BString, ByteVec};
-use gix::dir::entry::Status;
-use gix::index::entry::Stage;
 use ignore::gitignore::GitignoreBuilder;
 use tracing::{debug, info, trace, warn};
 use walkdir::WalkDir;
@@ -429,20 +426,6 @@
     }
 }
 
-impl From<gix::dir::entry::Kind> for FileType {
-    fn from(value: gix::dir::entry::Kind) -> Self {
-        use gix::dir::entry::Kind;
-        match value {
-            Kind::Untrackable => FileType::Other,
-            Kind::File => FileType::File {
-                maybe_symlink: false,
-            },
-            Kind::Symlink => FileType::Symlink,
-            Kind::Directory | Kind::Repository => FileType::Dir,
-        }
-    }
-}
-
 /// [`PathBuf`] with extra metadata.
 #[derive(Clone, Debug)]
 pub struct PathEntry {
@@ -569,14 +552,9 @@
 fn _list_files(pkg: &Package, gctx: &GlobalContext) -> CargoResult<Vec<PathEntry>> {
     let root = pkg.root();
     let no_include_option = pkg.manifest().include().is_empty();
-    let git_repo = if no_include_option {
-        discover_gix_repo(root)?
-    } else {
-        None
-    };
 
     let mut exclude_builder = GitignoreBuilder::new(root);
-    if no_include_option && git_repo.is_none() {
+    if no_include_option {
         // no include option and not git repo discovered (see rust-lang/cargo#7183).
         exclude_builder.add_line(None, ".*")?;
     }
@@ -623,232 +601,11 @@
         ignore_should_package(relative_path, is_dir)
     };
 
-    // Attempt Git-prepopulate only if no `include` (see rust-lang/cargo#4135).
-    if no_include_option {
-        if let Some(repo) = git_repo {
-            return list_files_gix(pkg, &repo, &filter, gctx);
-        }
-    }
     let mut ret = Vec::new();
     list_files_walk(pkg.root(), &mut ret, true, &filter, gctx)?;
     Ok(ret)
 }
 
-/// Returns [`Some(gix::Repository)`](gix::Repository) if the discovered repository
-/// (searched upwards from `root`) contains a tracked `<root>/Cargo.toml`.
-/// Otherwise, the caller should fall back on full file list.
-fn discover_gix_repo(root: &Path) -> CargoResult<Option<gix::Repository>> {
-    let repo = match gix::ThreadSafeRepository::discover(root) {
-        Ok(repo) => repo.to_thread_local(),
-        Err(e) => {
-            tracing::debug!(
-                "could not discover git repo at or above {}: {}",
-                root.display(),
-                e
-            );
-            return Ok(None);
-        }
-    };
-    let index = repo
-        .index_or_empty()
-        .with_context(|| format!("failed to open git index at {}", repo.path().display()))?;
-    let repo_root = repo.workdir().ok_or_else(|| {
-        anyhow::format_err!(
-            "did not expect repo at {} to be bare",
-            repo.path().display()
-        )
-    })?;
-    let repo_relative_path = match paths::strip_prefix_canonical(root, repo_root) {
-        Ok(p) => p,
-        Err(e) => {
-            warn!(
-                "cannot determine if path `{:?}` is in git repo `{:?}`: {:?}",
-                root, repo_root, e
-            );
-            return Ok(None);
-        }
-    };
-    let manifest_path = gix::path::join_bstr_unix_pathsep(
-        gix::path::to_unix_separators_on_windows(gix::path::into_bstr(repo_relative_path)),
-        "Cargo.toml",
-    );
-    if index.entry_index_by_path(&manifest_path).is_ok() {
-        return Ok(Some(repo));
-    }
-    // Package Cargo.toml is not in git, don't use git to guide our selection.
-    Ok(None)
-}
-
-/// Lists files relevant to building this package inside this source by
-/// traversing the git working tree, while avoiding ignored files.
-///
-/// This looks into Git sub-repositories as well, resolving them to individual files.
-/// Symlinks to directories will also be resolved, but walked as repositories if they
-/// point to one to avoid picking up `.git` directories.
-fn list_files_gix(
-    pkg: &Package,
-    repo: &gix::Repository,
-    filter: &dyn Fn(&Path, bool) -> bool,
-    gctx: &GlobalContext,
-) -> CargoResult<Vec<PathEntry>> {
-    debug!("list_files_gix {}", pkg.package_id());
-    let options = repo
-        .dirwalk_options()?
-        .emit_untracked(gix::dir::walk::EmissionMode::Matching)
-        .emit_ignored(None)
-        .emit_tracked(true)
-        .recurse_repositories(false)
-        .symlinks_to_directories_are_ignored_like_directories(true)
-        .emit_empty_directories(false);
-    let index = repo.index_or_empty()?;
-    let root = repo
-        .workdir()
-        .ok_or_else(|| anyhow::format_err!("can't list files on a bare repository"))?;
-    assert!(
-        root.is_absolute(),
-        "BUG: paths used internally are absolute, and the repo inherits that"
-    );
-
-    let pkg_path = pkg.root();
-    let repo_relative_pkg_path = pkg_path.strip_prefix(root).unwrap_or(Path::new(""));
-    let target_prefix = gix::path::to_unix_separators_on_windows(gix::path::into_bstr(
-        repo_relative_pkg_path.join("target/"),
-    ));
-    let package_prefix =
-        gix::path::to_unix_separators_on_windows(gix::path::into_bstr(repo_relative_pkg_path));
-
-    let pathspec = {
-        // Include the package root.
-        let mut include = BString::from(":(top)");
-        include.push_str(package_prefix.as_ref());
-
-        // Exclude the target directory.
-        let mut exclude = BString::from(":!(exclude,top)");
-        exclude.push_str(target_prefix.as_ref());
-
-        vec![include, exclude]
-    };
-
-    let mut files = Vec::<PathEntry>::new();
-    let mut subpackages_found = Vec::new();
-    for item in repo
-        .dirwalk_iter(index.clone(), pathspec, Default::default(), options)?
-        .filter(|res| {
-            // Don't include Cargo.lock if it is untracked. Packaging will
-            // generate a new one as needed.
-            // Also don't include untrackable directory entries, like FIFOs.
-            res.as_ref().map_or(true, |item| {
-                item.entry.disk_kind != Some(gix::dir::entry::Kind::Untrackable)
-                    && !(item.entry.status == Status::Untracked
-                        && item.entry.rela_path == "Cargo.lock")
-            })
-        })
-        .map(|res| {
-            res.map(|item| {
-                // Assumption: if a file tracked as a symlink in Git index, and
-                // the actual file type on disk is file, then it might be a
-                // plain text file symlink.
-                // There are exceptions like the file has changed from a symlink
-                // to a real text file, but hasn't been committed to Git index.
-                // Exceptions may be rare so we're okay with this now.
-                let maybe_plain_text_symlink = item.entry.index_kind
-                    == Some(gix::dir::entry::Kind::Symlink)
-                    && item.entry.disk_kind == Some(gix::dir::entry::Kind::File);
-                (
-                    item.entry.rela_path,
-                    item.entry.disk_kind,
-                    maybe_plain_text_symlink,
-                )
-            })
-        })
-        .chain(
-            // Append entries that might be tracked in `<pkg_root>/target/`.
-            index
-                .prefixed_entries(target_prefix.as_ref())
-                .unwrap_or_default()
-                .iter()
-                .filter(|entry| {
-                    // probably not needed as conflicts prevent this to run, but let's be explicit.
-                    entry.stage() == Stage::Unconflicted
-                })
-                .map(|entry| {
-                    (
-                        entry.path(&index).to_owned(),
-                        // Do not trust what's recorded in the index, enforce checking the disk.
-                        // This traversal is not part of a `status()`, and tracking things in `target/`
-                        // is rare.
-                        None,
-                        false,
-                    )
-                })
-                .map(Ok),
-        )
-    {
-        let (rela_path, kind, maybe_plain_text_symlink) = item?;
-        let file_path = root.join(gix::path::from_bstr(rela_path));
-        if file_path.file_name().and_then(|name| name.to_str()) == Some("Cargo.toml") {
-            // Keep track of all sub-packages found and also strip out all
-            // matches we've found so far. Note, though, that if we find
-            // our own `Cargo.toml`, we keep going.
-            let path = file_path.parent().unwrap();
-            if path != pkg_path {
-                debug!("subpackage found: {}", path.display());
-                files.retain(|p| !p.starts_with(path));
-                subpackages_found.push(path.to_path_buf());
-                continue;
-            }
-        }
-
-        // If this file is part of any other sub-package we've found so far,
-        // skip it.
-        if subpackages_found.iter().any(|p| file_path.starts_with(p)) {
-            continue;
-        }
-
-        let is_dir = kind.map_or(false, |kind| {
-            if kind == gix::dir::entry::Kind::Symlink {
-                // Symlinks must be checked to see if they point to a directory
-                // we should traverse.
-                file_path.is_dir()
-            } else {
-                kind.is_dir()
-            }
-        });
-        if is_dir {
-            // This could be a submodule, or a sub-repository. In any case, we prefer to walk
-            // it with git-support to leverage ignored files and to avoid pulling in entire
-            // .git repositories.
-            match gix::open(&file_path) {
-                Ok(sub_repo) => {
-                    files.extend(list_files_gix(pkg, &sub_repo, filter, gctx)?);
-                }
-                Err(_) => {
-                    list_files_walk(&file_path, &mut files, false, filter, gctx)?;
-                }
-            }
-        } else if (filter)(&file_path, is_dir) {
-            assert!(!is_dir);
-            trace!("  found {}", file_path.display());
-            let ty = match kind.map(Into::into) {
-                Some(FileType::File { .. }) => FileType::File {
-                    maybe_symlink: maybe_plain_text_symlink,
-                },
-                Some(ty) => ty,
-                None => FileType::Other,
-            };
-            files.push(PathEntry {
-                path: file_path,
-                ty,
-                // Git index doesn't include files from symlink directory,
-                // symlink dirs are handled in `list_files_walk`.
-                under_symlink_dir: false,
-            });
-        }
-    }
-
-    return Ok(files);
-}
-
 /// Lists files relevant to building this package inside this source by
 /// walking the filesystem from the package root path.
 ///
diff -urN cargo-0.89.0-orig/src/cargo/sources/registry/mod.rs cargo-0.89.0/src/cargo/sources/registry/mod.rs
--- cargo-0.89.0-orig/src/cargo/sources/registry/mod.rs	2025-05-10 20:10:32 +0900
+++ cargo-0.89.0/src/cargo/sources/registry/mod.rs	2025-08-10 06:03:38 +0900
@@ -209,7 +209,18 @@
 use crate::sources::PathSource;
 use crate::util::cache_lock::CacheLockMode;
 use crate::util::interning::InternedString;
-use crate::util::network::PollExt;
+trait PollExt<T> {
+    fn expect(self, msg: &str) -> T;
+}
+impl<T> PollExt<T> for Poll<T> {
+    #[track_caller]
+    fn expect(self, msg: &str) -> T {
+        match self {
+            Poll::Ready(val) => val,
+            Poll::Pending => panic!("{}", msg),
+        }
+    }
+}
 use crate::util::{hex, VersionExt};
 use crate::util::{restricted_names, CargoResult, Filesystem, GlobalContext, LimitErrorReader};
 
@@ -219,10 +230,7 @@
 /// Not to be confused with `.cargo-ok` file in git sources.
 const PACKAGE_SOURCE_LOCK: &str = ".cargo-ok";
 
-pub const CRATES_IO_INDEX: &str = "https://github.com/rust-lang/crates.io-index";
-pub const CRATES_IO_HTTP_INDEX: &str = "sparse+https://index.crates.io/";
 pub const CRATES_IO_REGISTRY: &str = "crates-io";
-pub const CRATES_IO_DOMAIN: &str = "crates.io";
 
 /// The content inside `.cargo-ok`.
 /// See [`RegistrySource::unpack_package`] for more.
@@ -443,12 +451,9 @@
     },
 }
 
-mod download;
-mod http_remote;
 pub(crate) mod index;
 pub use index::IndexSummary;
 mod local;
-mod remote;
 
 /// Generates a unique name for [`SourceId`] to have a unique path to put their
 /// index files.
@@ -468,39 +473,6 @@
 }
 
 impl<'gctx> RegistrySource<'gctx> {
-    /// Creates a [`Source`] of a "remote" registry.
-    /// It could be either an HTTP-based [`http_remote::HttpRegistry`] or
-    /// a Git-based [`remote::RemoteRegistry`].
-    ///
-    /// * `yanked_whitelist` --- Packages allowed to be used, even if they are yanked.
-    pub fn remote(
-        source_id: SourceId,
-        yanked_whitelist: &HashSet<PackageId>,
-        gctx: &'gctx GlobalContext,
-    ) -> CargoResult<RegistrySource<'gctx>> {
-        assert!(source_id.is_remote_registry());
-        let name = short_name(
-            source_id,
-            gctx.cli_unstable()
-                .git
-                .map_or(false, |features| features.shallow_index)
-                && !source_id.is_sparse(),
-        );
-        let ops = if source_id.is_sparse() {
-            Box::new(http_remote::HttpRegistry::new(source_id, gctx, &name)?) as Box<_>
-        } else {
-            Box::new(remote::RemoteRegistry::new(source_id, gctx, &name)) as Box<_>
-        };
-
-        Ok(RegistrySource::new(
-            source_id,
-            gctx,
-            &name,
-            ops,
-            yanked_whitelist,
-        ))
-    }
-
     /// Creates a [`Source`] of a local registry, with [`local::LocalRegistry`] under the hood.
     ///
     /// * `path` --- The root path of a local registry on the file system.
diff -urN cargo-0.89.0-orig/src/cargo/util/command_prelude.rs cargo-0.89.0/src/cargo/util/command_prelude.rs
--- cargo-0.89.0-orig/src/cargo/util/command_prelude.rs	2025-05-10 20:10:32 +0900
+++ cargo-0.89.0/src/cargo/util/command_prelude.rs	2025-08-10 06:03:38 +0900
@@ -4,7 +4,7 @@
 use crate::core::resolver::{CliFeatures, ForceAllTargets, HasDevUnits};
 use crate::core::{profiles::Profiles, shell, Edition, Package, Target, TargetKind, Workspace};
 use crate::ops::lockfile::LOCKFILE_NAME;
-use crate::ops::registry::RegistryOrIndex;
+use crate::ops::RegistryOrIndex;
 use crate::ops::{self, CompileFilter, CompileOptions, NewOptions, Packages, VersionControl};
 use crate::util::important_paths::find_root_manifest_for_wd;
 use crate::util::interning::InternedString;
diff -urN cargo-0.89.0-orig/src/cargo/util/context/mod.rs cargo-0.89.0/src/cargo/util/context/mod.rs
--- cargo-0.89.0-orig/src/cargo/util/context/mod.rs	2025-05-10 20:10:32 +0900
+++ cargo-0.89.0/src/cargo/util/context/mod.rs	2025-08-10 06:03:38 +0900
@@ -71,19 +71,13 @@
 use crate::core::global_cache_tracker::{DeferredGlobalLastUse, GlobalCacheTracker};
 use crate::core::shell::Verbosity;
 use crate::core::{features, CliUnstable, Shell, SourceId, Workspace, WorkspaceRootConfig};
-use crate::ops::RegistryCredentialConfig;
-use crate::sources::CRATES_IO_INDEX;
-use crate::sources::CRATES_IO_REGISTRY;
+use crate::sources::registry::CRATES_IO_REGISTRY;
 use crate::util::errors::CargoResult;
-use crate::util::network::http::configure_http_handle;
-use crate::util::network::http::http_handle;
 use crate::util::{closest_msg, internal, CanonicalUrl};
 use crate::util::{Filesystem, IntoUrl, IntoUrlWithBase, Rustc};
 use anyhow::{anyhow, bail, format_err, Context as _};
-use cargo_credential::Secret;
 use cargo_util::paths;
 use cargo_util_schemas::manifest::RegistryName;
-use curl::easy::Easy;
 use itertools::Itertools;
 use lazycell::LazyCell;
 use serde::de::IntoDeserializer as _;
@@ -111,8 +105,6 @@
 mod environment;
 use environment::Env;
 
-use super::auth::RegistryConfig;
-
 /// Helper macro for creating typed access methods.
 macro_rules! get_value_typed {
     ($name:ident, $ty:ty, $variant:ident, $expected:expr) => {
@@ -151,14 +143,6 @@
     FileDiscovery,
 }
 
-/// A previously generated authentication token and the data needed to determine if it can be reused.
-#[derive(Debug)]
-pub struct CredentialCacheValue {
-    pub token_value: Secret<String>,
-    pub expiration: Option<OffsetDateTime>,
-    pub operation_independent: bool,
-}
-
 /// Configuration information for cargo. This is not specific to a build, it is information
 /// relating to cargo itself.
 #[derive(Debug)]
@@ -198,8 +182,6 @@
     unstable_flags: CliUnstable,
     /// Cli flags of the form "-Z something"
     unstable_flags_cli: Option<Vec<String>>,
-    /// A handle on curl easy mode for http calls
-    easy: LazyCell<RefCell<Easy>>,
     /// Cache of the `SourceId` for crates.io
     crates_io_source_id: LazyCell<SourceId>,
     /// If false, don't cache `rustc --version --verbose` invocations
@@ -212,11 +194,6 @@
     env: Env,
     /// Tracks which sources have been updated to avoid multiple updates.
     updated_sources: LazyCell<RefCell<HashSet<SourceId>>>,
-    /// Cache of credentials from configuration or credential providers.
-    /// Maps from url to credential value.
-    credential_cache: LazyCell<RefCell<HashMap<CanonicalUrl, CredentialCacheValue>>>,
-    /// Cache of registry config from the `[registries]` table.
-    registry_config: LazyCell<RefCell<HashMap<SourceId, Option<RegistryConfig>>>>,
     /// Locks on the package and index caches.
     package_cache_lock: CacheLocker,
     /// Cached configuration parsed by Cargo
@@ -304,15 +281,12 @@
             },
             unstable_flags: CliUnstable::default(),
             unstable_flags_cli: None,
-            easy: LazyCell::new(),
             crates_io_source_id: LazyCell::new(),
             cache_rustc_info,
             creation_time: Instant::now(),
             target_dir: None,
             env,
             updated_sources: LazyCell::new(),
-            credential_cache: LazyCell::new(),
-            registry_config: LazyCell::new(),
             package_cache_lock: CacheLocker::new(),
             http_config: LazyCell::new(),
             future_incompat_config: LazyCell::new(),
@@ -519,20 +493,6 @@
             .borrow_mut()
     }
 
-    /// Cached credentials from credential providers or configuration.
-    pub fn credential_cache(&self) -> RefMut<'_, HashMap<CanonicalUrl, CredentialCacheValue>> {
-        self.credential_cache
-            .borrow_with(|| RefCell::new(HashMap::new()))
-            .borrow_mut()
-    }
-
-    /// Cache of already parsed registries from the `[registries]` table.
-    pub(crate) fn registry_config(&self) -> RefMut<'_, HashMap<SourceId, Option<RegistryConfig>>> {
-        self.registry_config
-            .borrow_with(|| RefCell::new(HashMap::new()))
-            .borrow_mut()
-    }
-
     /// Gets all config values from disk.
     ///
     /// This will lazy-load the values as necessary. Callers are responsible
@@ -1887,24 +1847,9 @@
         self.jobserver.as_ref()
     }
 
-    pub fn http(&self) -> CargoResult<&RefCell<Easy>> {
-        let http = self
-            .easy
-            .try_borrow_with(|| http_handle(self).map(RefCell::new))?;
-        {
-            let mut http = http.borrow_mut();
-            http.reset();
-            let timeout = configure_http_handle(self, &mut http)?;
-            timeout.configure(&mut http)?;
-        }
-        Ok(http)
-    }
-
     pub fn http_config(&self) -> CargoResult<&CargoHttpConfig> {
         self.http_config.try_borrow_with(|| {
             let mut http = self.get::<CargoHttpConfig>("http")?;
-            let curl_v = curl::Version::get();
-            disables_multiplexing_for_bad_curl(curl_v.version(), &mut http, self);
             Ok(http)
         })
     }
@@ -2021,6 +1966,9 @@
     pub fn crates_io_source_id(&self) -> CargoResult<SourceId> {
         let source_id = self.crates_io_source_id.try_borrow_with(|| {
             self.check_registry_index_not_set()?;
+            // NOTE(achurch): this has to be the original github URL to
+            // avoid obsolete lockfile errors with --locked
+            const CRATES_IO_INDEX: &str = "https://github.com/rust-lang/crates.io-index";
             let url = CRATES_IO_INDEX.into_url().unwrap();
             SourceId::for_alt_registry(&url, CRATES_IO_REGISTRY)
         })?;
@@ -2477,154 +2425,6 @@
     ::home::cargo_home_with_cwd(cwd).ok()
 }
 
-pub fn save_credentials(
-    gctx: &GlobalContext,
-    token: Option<RegistryCredentialConfig>,
-    registry: &SourceId,
-) -> CargoResult<()> {
-    let registry = if registry.is_crates_io() {
-        None
-    } else {
-        let name = registry
-            .alt_registry_key()
-            .ok_or_else(|| internal("can't save credentials for anonymous registry"))?;
-        Some(name)
-    };
-
-    // If 'credentials' exists, write to that for backward compatibility reasons.
-    // Otherwise write to 'credentials.toml'. There's no need to print the
-    // warning here, because it would already be printed at load time.
-    let home_path = gctx.home_path.clone().into_path_unlocked();
-    let filename = match gctx.get_file_path(&home_path, "credentials", false)? {
-        Some(path) => match path.file_name() {
-            Some(filename) => Path::new(filename).to_owned(),
-            None => Path::new("credentials.toml").to_owned(),
-        },
-        None => Path::new("credentials.toml").to_owned(),
-    };
-
-    let mut file = {
-        gctx.home_path.create_dir()?;
-        gctx.home_path
-            .open_rw_exclusive_create(filename, gctx, "credentials' config file")?
-    };
-
-    let mut contents = String::new();
-    file.read_to_string(&mut contents).with_context(|| {
-        format!(
-            "failed to read configuration file `{}`",
-            file.path().display()
-        )
-    })?;
-
-    let mut toml = parse_document(&contents, file.path(), gctx)?;
-
-    // Move the old token location to the new one.
-    if let Some(token) = toml.remove("token") {
-        let map = HashMap::from([("token".to_string(), token)]);
-        toml.insert("registry".into(), map.into());
-    }
-
-    if let Some(token) = token {
-        // login
-
-        let path_def = Definition::Path(file.path().to_path_buf());
-        let (key, mut value) = match token {
-            RegistryCredentialConfig::Token(token) => {
-                // login with token
-
-                let key = "token".to_string();
-                let value = ConfigValue::String(token.expose(), path_def.clone());
-                let map = HashMap::from([(key, value)]);
-                let table = CV::Table(map, path_def.clone());
-
-                if let Some(registry) = registry {
-                    let map = HashMap::from([(registry.to_string(), table)]);
-                    ("registries".into(), CV::Table(map, path_def.clone()))
-                } else {
-                    ("registry".into(), table)
-                }
-            }
-            RegistryCredentialConfig::AsymmetricKey((secret_key, key_subject)) => {
-                // login with key
-
-                let key = "secret-key".to_string();
-                let value = ConfigValue::String(secret_key.expose(), path_def.clone());
-                let mut map = HashMap::from([(key, value)]);
-                if let Some(key_subject) = key_subject {
-                    let key = "secret-key-subject".to_string();
-                    let value = ConfigValue::String(key_subject, path_def.clone());
-                    map.insert(key, value);
-                }
-                let table = CV::Table(map, path_def.clone());
-
-                if let Some(registry) = registry {
-                    let map = HashMap::from([(registry.to_string(), table)]);
-                    ("registries".into(), CV::Table(map, path_def.clone()))
-                } else {
-                    ("registry".into(), table)
-                }
-            }
-            _ => unreachable!(),
-        };
-
-        if registry.is_some() {
-            if let Some(table) = toml.remove("registries") {
-                let v = CV::from_toml(path_def, table)?;
-                value.merge(v, false)?;
-            }
-        }
-        toml.insert(key, value.into_toml());
-    } else {
-        // logout
-        if let Some(registry) = registry {
-            if let Some(registries) = toml.get_mut("registries") {
-                if let Some(reg) = registries.get_mut(registry) {
-                    let rtable = reg.as_table_mut().ok_or_else(|| {
-                        format_err!("expected `[registries.{}]` to be a table", registry)
-                    })?;
-                    rtable.remove("token");
-                    rtable.remove("secret-key");
-                    rtable.remove("secret-key-subject");
-                }
-            }
-        } else if let Some(registry) = toml.get_mut("registry") {
-            let reg_table = registry
-                .as_table_mut()
-                .ok_or_else(|| format_err!("expected `[registry]` to be a table"))?;
-            reg_table.remove("token");
-            reg_table.remove("secret-key");
-            reg_table.remove("secret-key-subject");
-        }
-    }
-
-    let contents = toml.to_string();
-    file.seek(SeekFrom::Start(0))?;
-    file.write_all(contents.as_bytes())
-        .with_context(|| format!("failed to write to `{}`", file.path().display()))?;
-    file.file().set_len(contents.len() as u64)?;
-    set_permissions(file.file(), 0o600)
-        .with_context(|| format!("failed to set permissions of `{}`", file.path().display()))?;
-
-    return Ok(());
-
-    #[cfg(unix)]
-    fn set_permissions(file: &File, mode: u32) -> CargoResult<()> {
-        use std::os::unix::fs::PermissionsExt;
-
-        let mut perms = file.metadata()?.permissions();
-        perms.set_mode(mode);
-        file.set_permissions(perms)?;
-        Ok(())
-    }
-
-    #[cfg(not(unix))]
-    #[allow(unused)]
-    fn set_permissions(file: &File, mode: u32) -> CargoResult<()> {
-        Ok(())
-    }
-}
-
 #[derive(Debug, Default, Deserialize, PartialEq)]
 #[serde(rename_all = "kebab-case")]
 pub struct CargoHttpConfig {
@@ -3113,34 +2913,6 @@
         }
     }
 }
-
-/// Disable HTTP/2 multiplexing for some broken versions of libcurl.
-///
-/// In certain versions of libcurl when proxy is in use with HTTP/2
-/// multiplexing, connections will continue stacking up. This was
-/// fixed in libcurl 8.0.0 in curl/curl@821f6e2a89de8aec1c7da3c0f381b92b2b801efc
-///
-/// However, Cargo can still link against old system libcurl if it is from a
-/// custom built one or on macOS. For those cases, multiplexing needs to be
-/// disabled when those versions are detected.
-fn disables_multiplexing_for_bad_curl(
-    curl_version: &str,
-    http: &mut CargoHttpConfig,
-    gctx: &GlobalContext,
-) {
-    use crate::util::network;
-
-    if network::proxy::http_proxy_exists(http, gctx) && http.multiplexing.is_none() {
-        let bad_curl_versions = ["7.87.0", "7.88.0", "7.88.1"];
-        if bad_curl_versions
-            .iter()
-            .any(|v| curl_version.starts_with(v))
-        {
-            tracing::info!("disabling multiplexing with proxy, curl version is {curl_version}");
-            http.multiplexing = Some(false);
-        }
-    }
-}
 
 #[cfg(test)]
 mod tests {
diff -urN cargo-0.89.0-orig/src/cargo/util/errors.rs cargo-0.89.0/src/cargo/util/errors.rs
--- cargo-0.89.0-orig/src/cargo/util/errors.rs	2025-05-10 20:10:32 +0900
+++ cargo-0.89.0/src/cargo/util/errors.rs	2025-08-10 06:03:38 +0900
@@ -1,5 +1,4 @@
 use anyhow::Error;
-use curl::easy::Easy;
 use std::fmt::{self, Write};
 use std::path::PathBuf;
 
@@ -7,110 +6,6 @@
 
 pub type CargoResult<T> = anyhow::Result<T>;
 
-/// These are headers that are included in error messages to help with
-/// diagnosing issues.
-pub const DEBUG_HEADERS: &[&str] = &[
-    // This is the unique ID that identifies the request in CloudFront which
-    // can be used for looking at the AWS logs.
-    "x-amz-cf-id",
-    // This is the CloudFront POP (Point of Presence) that identifies the
-    // region where the request was routed. This can help identify if an issue
-    // is region-specific.
-    "x-amz-cf-pop",
-    // The unique token used for troubleshooting S3 requests via AWS logs or support.
-    "x-amz-request-id",
-    // Another token used in conjunction with x-amz-request-id.
-    "x-amz-id-2",
-    // Whether or not there was a cache hit or miss (both CloudFront and Fastly).
-    "x-cache",
-    // The cache server that processed the request (Fastly).
-    "x-served-by",
-];
-
-#[derive(Debug)]
-pub struct HttpNotSuccessful {
-    pub code: u32,
-    pub url: String,
-    pub ip: Option<String>,
-    pub body: Vec<u8>,
-    pub headers: Vec<String>,
-}
-
-impl HttpNotSuccessful {
-    pub fn new_from_handle(
-        handle: &mut Easy,
-        initial_url: &str,
-        body: Vec<u8>,
-        headers: Vec<String>,
-    ) -> HttpNotSuccessful {
-        let ip = handle.primary_ip().ok().flatten().map(|s| s.to_string());
-        let url = handle
-            .effective_url()
-            .ok()
-            .flatten()
-            .unwrap_or(initial_url)
-            .to_string();
-        HttpNotSuccessful {
-            code: handle.response_code().unwrap_or(0),
-            url,
-            ip,
-            body,
-            headers,
-        }
-    }
-
-    /// Renders the error in a compact form.
-    pub fn display_short(&self) -> String {
-        self.render(false)
-    }
-
-    fn render(&self, show_headers: bool) -> String {
-        let mut result = String::new();
-        let body = std::str::from_utf8(&self.body)
-            .map(|s| truncate_with_ellipsis(s, 512))
-            .unwrap_or_else(|_| format!("[{} non-utf8 bytes]", self.body.len()));
-
-        write!(
-            result,
-            "failed to get successful HTTP response from `{}`",
-            self.url
-        )
-        .unwrap();
-        if let Some(ip) = &self.ip {
-            write!(result, " ({ip})").unwrap();
-        }
-        write!(result, ", got {}\n", self.code).unwrap();
-        if show_headers {
-            let headers: Vec<_> = self
-                .headers
-                .iter()
-                .filter(|header| {
-                    let Some((name, _)) = header.split_once(":") else {
-                        return false;
-                    };
-                    DEBUG_HEADERS.contains(&name.to_ascii_lowercase().trim())
-                })
-                .collect();
-            if !headers.is_empty() {
-                writeln!(result, "debug headers:").unwrap();
-                for header in headers {
-                    writeln!(result, "{header}").unwrap();
-                }
-            }
-        }
-        write!(result, "body:\n{body}").unwrap();
-        result
-    }
-}
-
-impl fmt::Display for HttpNotSuccessful {
-    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
-        f.write_str(&self.render(true))
-    }
-}
-
-impl std::error::Error for HttpNotSuccessful {}
-
 // =============================================================================
 // Verbose error
 
